/***********************************************************\
Copyright (C) James Boer, 2002. 
All rights reserved worldwide.

This software is provided "as is" without express or implied
warranties. You may freely copy and compile this source into
applications you distribute provided that the copyright text
below is included in the resulting source code, for example:
"Portions Copyright (C) James Boer, 2002"
\***********************************************************/

#if !defined(AFX_AUDIOTESTDLG_H__B46214A2_CD88_43A8_87A8_28E6DB9B6E62__INCLUDED_)
#define AFX_AUDIOTESTDLG_H__B46214A2_CD88_43A8_87A8_28E6DB9B6E62__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSystem;
class CSound2D;
class CSound3D;
class CListener;
class CSoundScript;
class CSegment;
class CMusicScript;
class CCDAudio;

class CEAXBuffer;
class CEAXListener;
class CZoomFX;

/////////////////////////////////////////////////////////////////////////////
// CAudioTestDlg dialog

class CAudioTestDlg : public CPropertySheet
{
// Construction
public:
	CAudioTestDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CAudioTestDlg)
	enum { IDD = IDD_AUDIOTEST_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAudioTestDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
	// Pointers to other dialog elements used for inter-dialog
	// communication.
public:
	CSystem*		m_pSystem;
	CSound2D*		m_pSound2D;
	CSound3D*		m_pSound3D;
	CListener*		m_pListener;
	CSoundScript*	m_pSoundScript;
	CSegment*		m_pSegment;
	CMusicScript*	m_pMusicScript;
	CCDAudio*		m_pCDAudio;

	CEAXBuffer*		m_pEAXBuffer;
	CEAXListener*	m_pEAXListener;
	CZoomFX*		m_pZoomFX;
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CAudioTestDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AUDIOTESTDLG_H__B46214A2_CD88_43A8_87A8_28E6DB9B6E62__INCLUDED_)
