/***********************************************************\
Copyright (C) James Boer, 2002. 
All rights reserved worldwide.

This software is provided "as is" without express or implied
warranties. You may freely copy and compile this source into
applications you distribute provided that the copyright text
below is included in the resulting source code, for example:
"Portions Copyright (C) James Boer, 2002"
\***********************************************************/
#if !defined(AFX_SEGMENT_H__75DC20FA_817D_42D4_8115_9ECBFBE661C6__INCLUDED_)
#define AFX_SEGMENT_H__75DC20FA_817D_42D4_8115_9ECBFBE661C6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Segment.h : header file
//

class CAudioTestDlg;

/////////////////////////////////////////////////////////////////////////////
// CSegment dialog

class CSegment : public CPropertyPage
{
	DECLARE_DYNCREATE(CSegment)

// Construction
public:
	CSegment();
	~CSegment();

// Dialog Data
	//{{AFX_DATA(CSegment)
	enum { IDD = IDD_PROPPAGE_MUSIC };
	CButton	m_Stop;
	CButton	m_Pause;
	CButton	m_Play;
	CListBox	m_Segments;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CSegment)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

public:
	void UpdateControls();
	void ClearList();
	CAudioTestDlg*	m_pTestDlg;
// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CSegment)
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void OnSegInitialize();
	afx_msg void OnSegDelete();
	afx_msg void OnLoadSegment();
	afx_msg void OnUnloadSegment();
	afx_msg void OnPlaySegment();
	afx_msg void OnPauseSegment();
	afx_msg void OnStopSegment();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnSelChangeListSegments();
	afx_msg void OnDblclkListSegments();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	HICON m_hPlayIcon;
	HICON m_hPauseIcon;
	HICON m_hStopIcon;

	bool m_bInit;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SEGMENT_H__75DC20FA_817D_42D4_8115_9ECBFBE661C6__INCLUDED_)
