/***********************************************************\
Copyright (C) James Boer, 2002. 
All rights reserved worldwide.

This software is provided "as is" without express or implied
warranties. You may freely copy and compile this source into
applications you distribute provided that the copyright text
below is included in the resulting source code, for example:
"Portions Copyright (C) James Boer, 2002"
\***********************************************************/
#if !defined(AFX_SOUND3D_H__FF47D032_CFDC_4EA3_93FF_4FCF538C8D7E__INCLUDED_)
#define AFX_SOUND3D_H__FF47D032_CFDC_4EA3_93FF_4FCF538C8D7E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Sound3D.h : header file
//
#include "Audio.h"

class CAudioTestDlg;

/////////////////////////////////////////////////////////////////////////////
// CSound3D dialog

class CSound3D : public CPropertyPage
{
	DECLARE_DYNCREATE(CSound3D)

// Construction
public:
	CSound3D();
	~CSound3D();

// Dialog Data
	//{{AFX_DATA(CSound3D)
	enum { IDD = IDD_PROPPAGE_3DSOUND };
	CSliderCtrl	m_ZPos;
	CSliderCtrl	m_YPos;
	CSliderCtrl	m_XPos;
	CButton	m_Stop;
	CButton	m_Pause;
	CButton	m_Play;
	CListBox	m_3DSounds;
	CSliderCtrl	m_Cursor;
	CSliderCtrl	m_Pitch;
	CSliderCtrl	m_Volume;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CSound3D)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

public:
	void UpdateControls();
	void ClearList();
	CAudioTestDlg*		m_pTestDlg;

	Audio::ISound3D*	GetCurrentSound();
// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CSound3D)
	virtual BOOL OnInitDialog();
	afx_msg void On3dInitialize();
	afx_msg void On3dDelete();
	afx_msg void OnLoad3d();
	afx_msg void OnUnload3d();
	afx_msg void OnPlay3d();
	afx_msg void OnPause3d();
	afx_msg void OnStop3d();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSelChangeList3dSounds();
	afx_msg void OnDestroy();
	afx_msg void OnBufferEAX();
	afx_msg void OnZoomFx();
	afx_msg void OnDblclkList3dsounds();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	HICON m_hPlayIcon;
	HICON m_hPauseIcon;
	HICON m_hStopIcon;

	UINT m_nCursorTimer;

	bool m_bInit;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SOUND3D_H__FF47D032_CFDC_4EA3_93FF_4FCF538C8D7E__INCLUDED_)
