/***********************************************************\
Copyright (C) James Boer, 2002. 
All rights reserved worldwide.

This software is provided "as is" without express or implied
warranties. You may freely copy and compile this source into
applications you distribute provided that the copyright text
below is included in the resulting source code, for example:
"Portions Copyright (C) James Boer, 2002"
\***********************************************************/
#if !defined(AFX_SYSTEM_H__AD429169_5A7F_4AF2_AE8D_753958D8C79C__INCLUDED_)
#define AFX_SYSTEM_H__AD429169_5A7F_4AF2_AE8D_753958D8C79C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// System.h : header file
//


class CAudioTestDlg;

/////////////////////////////////////////////////////////////////////////////
// CSystem dialog

class CSystem : public CPropertyPage
{
	DECLARE_DYNCREATE(CSystem)

// Construction
public:
	CSystem();
	~CSystem();

// Dialog Data
	//{{AFX_DATA(CSystem)
	enum { IDD = IDD_PROPPAGE_SYSTEM };
	CButton	m_CacheBuffers;
	CButton	m_AutoStream;
	CButton	m_UseZoomFX;
	CButton	m_UseEAX;
	CEdit	m_Force2DSoftware;
	CEdit	m_Force3DSoftware;
	CEdit	m_SegmentsLoaded;
	CEdit	m_3DLoaded;
	CEdit	m_2DLoaded;
	CSpinButtonCtrl	m_SegmentMax;
	CSpinButtonCtrl	m_3DSoftwareBufferMax;
	CSpinButtonCtrl	m_3DHardwareBufferMin;
	CSpinButtonCtrl	m_3DHardwareBufferMax;
	CSpinButtonCtrl	m_2DSoftwareBufferMax;
	CSpinButtonCtrl	m_2DHardwareBufferMin;
	CSpinButtonCtrl	m_2DHardwareBufferMax;
	CComboBox	m_OptimalRate;
	CButton	m_UseMusicReverb;
	CButton	m_LoadAsync;
	CButton	m_ForceSoftware;
	CSliderCtrl	m_SoundVolume;
	CSliderCtrl	m_MusicVolume;
	CButton	m_PauseAll;
	CButton	m_StopAll;
	CButton	m_ResumeAll;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CSystem)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

public:
	void UpdateStats();
	CAudioTestDlg*	m_pTestDlg;
// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CSystem)
	afx_msg void OnInitialize();
	afx_msg void OnTerm();
	virtual BOOL OnInitDialog();
	afx_msg void OnResumeall();
	afx_msg void OnPauseall();
	afx_msg void OnStopall();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	HICON m_hPlayIcon;
	HICON m_hPauseIcon;
	HICON m_hStopIcon;

	UINT m_nSoundVolumeUpdateTimer;
	UINT m_nMusicVolumeUpdateTimer;
	UINT m_nStatsTimer;

	HGDIOBJ m_hFont;

};
//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SYSTEM_H__AD429169_5A7F_4AF2_AE8D_753958D8C79C__INCLUDED_)
