// ZoomFX.cpp : implementation file
//

#include "stdafx.h"
#include "audiotest.h"
#include "ZoomFX.h"
#include "AudioTestDlg.h"
#include "Sound3D.h"

using namespace Audio;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CZoomFX dialog


CZoomFX::CZoomFX(CWnd* pParent /*=NULL*/)
	: CDialog(CZoomFX::IDD, pParent)
{
	//{{AFX_DATA_INIT(CZoomFX)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_bInit = false;
}


void CZoomFX::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CZoomFX)
	DDX_Control(pDX, IDC_SPIN_MACRO_FX, m_MacroFX);
	DDX_Control(pDX, IDC_EDIT_ZOOMFX_TOP_Z, m_TopZ);
	DDX_Control(pDX, IDC_EDIT_ZOOMFX_TOP_Y, m_TopY);
	DDX_Control(pDX, IDC_EDIT_ZOOMFX_TOP_X, m_TopX);
	DDX_Control(pDX, IDC_EDIT_ZOOMFX_MIN_Z, m_MinZ);
	DDX_Control(pDX, IDC_EDIT_ZOOMFX_MIN_Y, m_MinY);
	DDX_Control(pDX, IDC_EDIT_ZOOMFX_MIN_X, m_MinX);
	DDX_Control(pDX, IDC_EDIT_ZOOMFX_MAX_Z, m_MaxZ);
	DDX_Control(pDX, IDC_EDIT_ZOOMFX_MAX_Y, m_MaxY);
	DDX_Control(pDX, IDC_EDIT_ZOOMFX_MAX_X, m_MaxX);
	DDX_Control(pDX, IDC_EDIT_ZOOMFX_FRONT_Z, m_FrontZ);
	DDX_Control(pDX, IDC_EDIT_ZOOMFX_FRONT_Y, m_FrontY);
	DDX_Control(pDX, IDC_EDIT_ZOOMFX_FRONT_X, m_FrontX);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CZoomFX, CDialog)
	//{{AFX_MSG_MAP(CZoomFX)
	ON_EN_CHANGE(IDC_EDIT_MACRO_FX, OnChangeEditMacroFx)
	ON_EN_CHANGE(IDC_EDIT_ZOOMFX_MIN_X, OnChangeEditZoomfxMinX)
	ON_EN_CHANGE(IDC_EDIT_ZOOMFX_MIN_Y, OnChangeEditZoomfxMinY)
	ON_EN_CHANGE(IDC_EDIT_ZOOMFX_MIN_Z, OnChangeEditZoomfxMinZ)
	ON_EN_CHANGE(IDC_EDIT_ZOOMFX_MAX_X, OnChangeEditZoomfxMaxX)
	ON_EN_CHANGE(IDC_EDIT_ZOOMFX_MAX_Y, OnChangeEditZoomfxMaxY)
	ON_EN_CHANGE(IDC_EDIT_ZOOMFX_MAX_Z, OnChangeEditZoomfxMaxZ)
	ON_EN_CHANGE(IDC_EDIT_ZOOMFX_FRONT_X, OnChangeEditZoomfxFrontX)
	ON_EN_CHANGE(IDC_EDIT_ZOOMFX_FRONT_Y, OnChangeEditZoomfxFrontY)
	ON_EN_CHANGE(IDC_EDIT_ZOOMFX_FRONT_Z, OnChangeEditZoomfxFrontZ)
	ON_EN_CHANGE(IDC_EDIT_ZOOMFX_TOP_X, OnChangeEditZoomfxTopX)
	ON_EN_CHANGE(IDC_EDIT_ZOOMFX_TOP_Y, OnChangeEditZoomfxTopY)
	ON_EN_CHANGE(IDC_EDIT_ZOOMFX_TOP_Z, OnChangeEditZoomfxTopZ)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CZoomFX message handlers

BOOL CZoomFX::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_bInit = true;

	m_Props.Clear();

	m_MacroFX.SetRange(0, 200);
	m_MacroFX.SetPos(100);
	
	UpdateControls();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
void CZoomFX::PostNcDestroy() 
{
	CDialog::PostNcDestroy();
	if(m_pTestDlg)
		m_pTestDlg->m_pZoomFX = 0;
	delete this;
}

void CZoomFX::OnOK() 
{
	CDialog::DestroyWindow();
}

void CZoomFX::UpdateControls()
{
	ISound3D* pSound3D = m_pTestDlg->m_pSound3D->GetCurrentSound();

	if(pSound3D)
		pSound3D->ZoomFX()->GetProperties(m_Props);

	CString sVal;

	sVal.Format("%.2f", m_Props.box.vMin.x);
	m_MinX.SetWindowText(sVal);
	sVal.Format("%.2f", m_Props.box.vMin.y);
	m_MinY.SetWindowText(sVal);
	sVal.Format("%.2f", m_Props.box.vMin.z);
	m_MinZ.SetWindowText(sVal);

	sVal.Format("%.2f", m_Props.box.vMax.x);
	m_MaxX.SetWindowText(sVal);
	sVal.Format("%.2f", m_Props.box.vMax.y);
	m_MaxY.SetWindowText(sVal);
	sVal.Format("%.2f", m_Props.box.vMax.z);
	m_MaxZ.SetWindowText(sVal);

	sVal.Format("%.2f", m_Props.orientation.vTop.x);
	m_TopX.SetWindowText(sVal);
	sVal.Format("%.2f", m_Props.orientation.vTop.y);
	m_TopY.SetWindowText(sVal);
	sVal.Format("%.2f", m_Props.orientation.vTop.z);
	m_TopZ.SetWindowText(sVal);

	sVal.Format("%.2f", m_Props.orientation.vFront.x);
	m_FrontX.SetWindowText(sVal);
	sVal.Format("%.2f", m_Props.orientation.vFront.y);
	m_FrontY.SetWindowText(sVal);
	sVal.Format("%.2f", m_Props.orientation.vFront.z);
	m_FrontZ.SetWindowText(sVal);

	m_MacroFX.SetPos(m_Props.lMacroFx);
}



void CZoomFX::OnChangeEditMacroFx() 
{
	if(!m_bInit) return;
	m_Props.lMacroFx = m_MacroFX.GetPos();
	ISound3D* pSound3D = m_pTestDlg->m_pSound3D->GetCurrentSound();
	if(pSound3D)
		pSound3D->ZoomFX()->SetProperties(m_Props);
}

void CZoomFX::OnChangeEditZoomfxMinX() 
{
	if(!m_bInit) return;
	CString sVal;
	m_MinX.GetWindowText(sVal);
	m_Props.box.vMin.x = atof(sVal);
	ISound3D* pSound3D = m_pTestDlg->m_pSound3D->GetCurrentSound();
	if(pSound3D)
		pSound3D->ZoomFX()->SetProperties(m_Props);
}

void CZoomFX::OnChangeEditZoomfxMinY() 
{
	if(!m_bInit) return;
	CString sVal;
	m_MinY.GetWindowText(sVal);
	m_Props.box.vMin.y = atof(sVal);
	ISound3D* pSound3D = m_pTestDlg->m_pSound3D->GetCurrentSound();
	if(pSound3D)
		pSound3D->ZoomFX()->SetProperties(m_Props);
}

void CZoomFX::OnChangeEditZoomfxMinZ() 
{
	if(!m_bInit) return;
	CString sVal;
	m_MinZ.GetWindowText(sVal);
	m_Props.box.vMin.z = atof(sVal);
	ISound3D* pSound3D = m_pTestDlg->m_pSound3D->GetCurrentSound();
	if(pSound3D)
		pSound3D->ZoomFX()->SetProperties(m_Props);
}

void CZoomFX::OnChangeEditZoomfxMaxX() 
{
	if(!m_bInit) return;
	CString sVal;
	m_MaxX.GetWindowText(sVal);
	m_Props.box.vMax.x = atof(sVal);
	ISound3D* pSound3D = m_pTestDlg->m_pSound3D->GetCurrentSound();
	if(pSound3D)
		pSound3D->ZoomFX()->SetProperties(m_Props);
}

void CZoomFX::OnChangeEditZoomfxMaxY() 
{
	if(!m_bInit) return;
	CString sVal;
	m_MaxY.GetWindowText(sVal);
	m_Props.box.vMax.y = atof(sVal);
	ISound3D* pSound3D = m_pTestDlg->m_pSound3D->GetCurrentSound();
	if(pSound3D)
		pSound3D->ZoomFX()->SetProperties(m_Props);
}

void CZoomFX::OnChangeEditZoomfxMaxZ() 
{
	if(!m_bInit) return;
	CString sVal;
	m_MaxZ.GetWindowText(sVal);
	m_Props.box.vMax.z = atof(sVal);
	ISound3D* pSound3D = m_pTestDlg->m_pSound3D->GetCurrentSound();
	if(pSound3D)
		pSound3D->ZoomFX()->SetProperties(m_Props);
}

void CZoomFX::OnChangeEditZoomfxFrontX() 
{
	if(!m_bInit) return;
	CString sVal;
	m_FrontX.GetWindowText(sVal);
	m_Props.orientation.vFront.x = atof(sVal);
	ISound3D* pSound3D = m_pTestDlg->m_pSound3D->GetCurrentSound();
	if(pSound3D)
		pSound3D->ZoomFX()->SetProperties(m_Props);
}

void CZoomFX::OnChangeEditZoomfxFrontY() 
{
	if(!m_bInit) return;
	CString sVal;
	m_FrontY.GetWindowText(sVal);
	m_Props.orientation.vFront.y = atof(sVal);
	ISound3D* pSound3D = m_pTestDlg->m_pSound3D->GetCurrentSound();
	if(pSound3D)
		pSound3D->ZoomFX()->SetProperties(m_Props);
}

void CZoomFX::OnChangeEditZoomfxFrontZ() 
{
	if(!m_bInit) return;
	CString sVal;
	m_FrontZ.GetWindowText(sVal);
	m_Props.orientation.vFront.z = atof(sVal);
	ISound3D* pSound3D = m_pTestDlg->m_pSound3D->GetCurrentSound();
	if(pSound3D)
		pSound3D->ZoomFX()->SetProperties(m_Props);
}

void CZoomFX::OnChangeEditZoomfxTopX() 
{
	if(!m_bInit) return;
	CString sVal;
	m_TopX.GetWindowText(sVal);
	m_Props.orientation.vTop.x = atof(sVal);
	ISound3D* pSound3D = m_pTestDlg->m_pSound3D->GetCurrentSound();
	if(pSound3D)
		pSound3D->ZoomFX()->SetProperties(m_Props);
}

void CZoomFX::OnChangeEditZoomfxTopY() 
{
	if(!m_bInit) return;
	CString sVal;
	m_TopY.GetWindowText(sVal);
	m_Props.orientation.vTop.y = atof(sVal);
	ISound3D* pSound3D = m_pTestDlg->m_pSound3D->GetCurrentSound();
	if(pSound3D)
		pSound3D->ZoomFX()->SetProperties(m_Props);
}

void CZoomFX::OnChangeEditZoomfxTopZ() 
{
	if(!m_bInit) return;
	CString sVal;
	m_TopZ.GetWindowText(sVal);
	m_Props.orientation.vTop.z = atof(sVal);
	ISound3D* pSound3D = m_pTestDlg->m_pSound3D->GetCurrentSound();
	if(pSound3D)
		pSound3D->ZoomFX()->SetProperties(m_Props);
}
