// ScriptTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ScriptTest.h"
#include "ScriptTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScriptTestDlg dialog

CScriptTestDlg::CScriptTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScriptTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScriptTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pScript = 0;
}

void CScriptTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScriptTestDlg)
	DDX_Control(pDX, IDC_SPIN_PLAYER_STRENGTH, m_PlayerStrength);
	DDX_Control(pDX, IDC_SPIN_MONSTER_STRENGTH, m_MonsterStrength);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CScriptTestDlg, CDialog)
	//{{AFX_MSG_MAP(CScriptTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_ENCOUNTER_MONSTER, OnEncounterMonster)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScriptTestDlg message handlers

BOOL CScriptTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_MonsterStrength.SetRange(1, 5);
	m_MonsterStrength.SetPos(1);
	m_PlayerStrength.SetRange(1, 5);
	m_PlayerStrength.SetPos(1);

	AudioMgrInit init;
	init.m_hWnd = ::AfxGetMainWnd()->GetSafeHwnd();
	AudioMgr()->Init(init);

	if(!AudioMgr()->CreateAudioScript(m_pScript))
		AfxMessageBox("Could not create audio script");
	AudioScriptInit asinit;
	asinit.m_bMusic = false;
	asinit.m_sFileName = "..\\data\\dmscript\\Voice Script.spt";
	m_pScript->Init(asinit);
	m_pScript->Load();
	
	m_pScript->SetVariable("PlayerStrength", 3);
	m_pScript->SetVariable("MonsterStrength", 3);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CScriptTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CScriptTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CScriptTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CScriptTestDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	AudioMgr()->Term();
	
}

void CScriptTestDlg::OnEncounterMonster() 
{
	m_pScript->SetVariable("PlayerStrength", m_PlayerStrength.GetPos());
	m_pScript->SetVariable("MonsterStrength", m_MonsterStrength.GetPos());
	m_pScript->CallRoutine("EncounterMonster");
}
